stages:
    - stage_1
    - stage_2
    - stage_3
    - stage_4

default:
    image: alpine:latest

job1:
    stage: stage_1
    script: 
        - echo 'J1'
        - sleep 30 

job2:
    stage: stage_1
    script: 
        - echo 'J2'
        - sleep 15

job3:
    stage: stage_1
    script: 
        - echo 'J3'
        - sleep 2

job4:
    stage: stage_2
    needs: [job1,job2]
    script: 
        - echo 'J4'

job5:
    stage: stage_2
    needs: [job3]
    script: 
        - echo 'J5'

job6:
    stage: stage_3
    needs: [job4]
    script: 
        - echo 'J6'

job7:
    stage: stage_3
    needs: [job2,job5]
    script: 
        - echo 'J7'

job8:
    stage: stage_4
    needs: [job1]
    script: 
        - echo 'J8'

job9:
    stage: stage_4
    needs: [job6,job7]
    script: 
        - echo 'J9'

job10:
    stage: stage_4
    needs: [job5]
    script: 
        - echo 'J10'